diff --git a/test/contrib/posixtestsuite-1.5.2/Makefile b/test/contrib/posixtestsuite-1.5.2/Makefile
index 5fcc0e0c8c..9a3b1b5bec 100644
--- a/test/contrib/posixtestsuite-1.5.2/Makefile
+++ b/test/contrib/posixtestsuite-1.5.2/Makefile
@@ -32,9 +32,9 @@ LOGFILE = $(top_builddir)/logfile
 LDFLAGS := $(shell cat LDFLAGS | grep -v \^\#)
 
 RUN_TESTS := $(shell $(top_builddir)/locate-test \
-             --execs $(top_builddir)/$(POSIX_TARGET))
+	     --execs $(top_builddir)/$(POSIX_TARGET))
 BUILD_TESTS := $(shell $(top_builddir)/locate-test \
-               --buildable $(top_builddir)/$(POSIX_TARGET))
+	       --buildable $(top_builddir)/$(POSIX_TARGET))
 FUNCTIONAL_MAKE := $(shell $(top_builddir)/locate-test --fmake)
 FUNCTIONAL_RUN := $(shell $(top_builddir)/locate-test --frun)
 STRESS_MAKE := $(shell $(top_builddir)/locate-test --smake)
@@ -47,6 +47,23 @@ all: build-tests run-tests
 
 build-tests: $(BUILD_TESTS:.c=.test)
 run-tests: $(RUN_TESTS:.test=.run-test)
+	@echo "" | tee -a $(LOGFILE)
+	@echo "BUILD RESULTS" | tee -a $(LOGFILE)
+	@echo "-----------------------------------" | tee -a $(LOGFILE)
+	@echo "BUILD FAILED:          "`grep -cw "build: FAILED:" $(LOGFILE)` | tee -a $(LOGFILE)
+	@echo "LINK FAILED:           "`grep -cw "link: FAILED:" $(LOGFILE)` | tee -a $(LOGFILE)
+	@echo "BUILD PASSED:          "`grep -cw "build: PASS" $(LOGFILE)` | tee -a $(LOGFILE)
+	@echo "LINK PASSED:           "`grep -cw "link: PASS" $(LOGFILE)` | tee -a $(LOGFILE)
+	@echo "" | tee -a $(LOGFILE)
+	@echo "EXECUTION PASSED:      "`grep -cw "execution: PASS" $(LOGFILE)` | tee -a $(LOGFILE)
+	@echo "EXECUTION FAILED:      "`grep -cw "execution: FAILED:" $(LOGFILE)` | tee -a $(LOGFILE)
+	@echo "EXECUTION UNRESOLVED:  "`grep -cw "execution: UNRESOLVED:" $(LOGFILE)` | tee -a $(LOGFILE)
+	@echo "EXECUTION UNSUPPORTED: "`grep -cw "execution: UNSUPPORTED:" $(LOGFILE)` | tee -a $(LOGFILE)
+	@echo "EXECUTION UNTESTED:    "`grep -cw "execution: UNTESTED:" $(LOGFILE)` | tee -a $(LOGFILE)
+	@echo "EXECUTION INTERRUPTED: "`grep -cw "execution: INTERRUPTED:" $(LOGFILE)` | tee -a $(LOGFILE)
+	@echo "EXECUTION HUNG:        "`grep -cw "execution: HUNG:" $(LOGFILE)` | tee -a $(LOGFILE)
+	@echo "EXECUTION SEGV:        XXX  " | tee -a $(LOGFILE)
+	@echo "EXECUTION OTHERS:      XXX  " | tee -a $(LOGFILE)
 
 functional-tests: functional-make functional-run
 stress-tests: stress-make stress-run
@@ -54,24 +71,28 @@ stress-tests: stress-make stress-run
 tests-pretty:
 	$(MAKE) all | column -t -s:
 
-CFLAGS = -g -O2 -Wall -Werror -D_POSIX_C_SOURCE=200112L
+#CFLAGS = -g -O2 -Wall -Werror -D_POSIX_C_SOURCE=200112L
+CC=c99
+CFLAGS = -g -DBSD -D_POSIX_C_SOURCE=200112L
 
 # add -std=c99, -std=gnu99 if compiler supports it (gcc-2.95.3 does not).
-check_gcc = $(shell if $(CC) $(1) -S -o /dev/null -xc /dev/null > /dev/null 2>&1; then echo "$(1)"; else echo "$(2)"; fi)
-CFLAGS += $(call check_gcc,-std=c99,)
-CFLAGS += $(call check_gcc,-std=gnu99,)
+#check_gcc = $(shell if $(CC) $(1) -S -o /dev/null -xc /dev/null > /dev/null 2>&1; then echo "$(1)"; else echo "$(2)"; fi)
+#CFLAGS += $(call check_gcc,-std=c99,)
+#CFLAGS += $(call check_gcc,-std=gnu99,)
 
 INCLUDE = -Iinclude
 
 # FIXME: exaust cmd line length
 clean:
 	@rm -f $(LOGFILE)
+# Core dumps
+	@rm -f $(top_builddir)/*.core
 # Timeout helper files
-	@rm -f $(top_builddir)/t0{,.val}
+	@rm -f $(top_builddir)/t0 $(top_builddir)/t0.val
 # Built runnable tests
 	@find $(top_builddir) -iname \*.test | xargs -n 40 rm -f {}
 	@find $(top_builddir) -iname \*~ -o -iname \*.o | xargs -n 40 rm -f {}
-	@$(foreach DIR,$(FUNCTIONAL_MAKE),make -C $(DIR) clean >> /dev/null 2>&1;) >> /dev/null 2>&1
+	@$(foreach DIR,$(FUNCTIONAL_MAKE),$(MAKE) -C $(DIR) clean >> /dev/null 2>&1;) >> /dev/null 2>&1
 
 # Rule to run a build test
 # If the .o doesn't export main, then we don't need to link
@@ -86,7 +107,7 @@ clean:
 		echo "$(@:.test=): link: PASS" | tee -a $(LOGFILE); \
 	else \
 		( \
-			echo "$(@:.test=): link: FAILED. Linker output: "; \
+			echo "$(@:.test=): link: FAILED: Linker output: "; \
 			cat $$COMPLOG; \
 		) >> $(LOGFILE); \
 		echo "$(@:.test=): link: FAILED "; \
@@ -139,7 +160,7 @@ clean:
 
 $(top_builddir)/t0: $(top_builddir)/t0.c
 	@echo Building timeout helper files; \
-	$(CC) -O2 -o $@ $<
+	$(CC) -o $@ $<
 
 $(top_builddir)/t0.val: $(top_builddir)/t0
 	echo `$(top_builddir)/t0 0; echo $$?` > $(top_builddir)/t0.val
@@ -179,7 +200,7 @@ $(top_builddir)/t0.val: $(top_builddir)/t0
 
 # Functional/Stress test build and execution
 functional-make:
-	$(foreach DIR,$(FUNCTIONAL_MAKE),make -C $(DIR);)
+	$(foreach DIR,$(FUNCTIONAL_MAKE),$(MAKE) -C $(DIR);)
 
 .PHONY: $(FUNCTIONAL_RUN)
 
@@ -190,7 +211,7 @@ $(FUNCTIONAL_RUN):
 	cd $(PWD)
 
 stress-make:
-	$(foreach DIR,$(STRESS_MAKE),make -C $(DIR);)
+	$(foreach DIR,$(STRESS_MAKE),$(MAKE) -C $(DIR);)
 
 .PHONY: $(STRESS_RUN)
 