diff --git a/sys/vm/swap_pager.c b/sys/vm/swap_pager.c
index 1243f11d2a..ad7448e6b6 100644
--- a/sys/vm/swap_pager.c
+++ b/sys/vm/swap_pager.c
@@ -132,7 +132,7 @@
 #define SWBIO_READ	0x01
 #define SWBIO_WRITE	0x02
 #define SWBIO_SYNC	0x04
-#define SWBIO_TTC	0x08	/* for VM_PAGER_TRY_TO_CACHE */
+#define SWBIO_TTC	0x08	/* for OBJPC_TRY_TO_CACHE */
 
 struct swfreeinfo {
 	vm_object_t	object;
@@ -1622,7 +1622,7 @@ swap_pager_putpages(vm_object_t object, vm_page_t *m, int count,
 	if (curthread != pagethread &&
 	    curthread != emergpager &&
 	    swap_user_async == 0) {
-		flags |= VM_PAGER_PUT_SYNC;
+		flags |= OBJPC_SYNC;
 	}
 
 	/*
@@ -1721,7 +1721,7 @@ swap_pager_putpages(vm_object_t object, vm_page_t *m, int count,
 		 *
 		 * Use the KVABIO API to avoid synchronizing the pmap.
 		 */
-		if ((flags & VM_PAGER_PUT_SYNC))
+		if ((flags & OBJPC_SYNC))
 			bp = getpbuf_kva(&nsw_wcount_sync);
 		else
 			bp = getpbuf_kva(&nsw_wcount_async);
@@ -1760,7 +1760,7 @@ swap_pager_putpages(vm_object_t object, vm_page_t *m, int count,
 		/*
 		 * asynchronous
 		 */
-		if ((flags & VM_PAGER_PUT_SYNC) == 0) {
+		if ((flags & OBJPC_SYNC) == 0) {
 			bio->bio_done = swp_pager_async_iodone;
 			BUF_KERNPROC(bp);
 			vn_strategy(swapdev_vp, bio);
@@ -1779,7 +1779,7 @@ swap_pager_putpages(vm_object_t object, vm_page_t *m, int count,
 		 * double-free.
 		 */
 		bio->bio_caller_info1.index |= SWBIO_SYNC;
-		if (flags & VM_PAGER_TRY_TO_CACHE)
+		if (flags & OBJPC_TRY_TO_CACHE)
 			bio->bio_caller_info1.index |= SWBIO_TTC;
 		bio->bio_done = biodone_sync;
 		bio->bio_flags |= BIO_SYNC;
diff --git a/sys/vm/vm_object.c b/sys/vm/vm_object.c
index 7a807e892a..b2706d78e0 100644
--- a/sys/vm/vm_object.c
+++ b/sys/vm/vm_object.c
@@ -951,8 +951,8 @@ vm_object_page_clean(vm_object_t object, vm_pindex_t start, vm_pindex_t end,
 	}
 
 	pagerflags = (flags & (OBJPC_SYNC | OBJPC_INVAL)) ?
-			VM_PAGER_PUT_SYNC : VM_PAGER_CLUSTER_OK;
-	pagerflags |= (flags & OBJPC_INVAL) ? VM_PAGER_PUT_INVAL : 0;
+			OBJPC_SYNC : OBJPC_CLUSTER_OK;
+	pagerflags |= (flags & OBJPC_INVAL) ? OBJPC_INVAL : 0;
 
 	vp = object->handle;
 
@@ -1165,7 +1165,7 @@ vm_object_page_collect_flush(vm_object_t object, vm_page_t p, int pagerflags)
 			break;
 		if (tp == NULL)
 			break;
-		if ((pagerflags & VM_PAGER_IGNORE_CLEANCHK) == 0 &&
+		if ((pagerflags & OBJPC_IGNORE_CLEANCHK) == 0 &&
 		    (tp->flags & PG_CLEANCHK) == 0) {
 			vm_page_wakeup(tp);
 			break;
@@ -1197,7 +1197,7 @@ vm_object_page_collect_flush(vm_object_t object, vm_page_t p, int pagerflags)
 			break;
 		if (tp == NULL)
 			break;
-		if ((pagerflags & VM_PAGER_IGNORE_CLEANCHK) == 0 &&
+		if ((pagerflags & OBJPC_IGNORE_CLEANCHK) == 0 &&
 		    (tp->flags & PG_CLEANCHK) == 0) {
 			vm_page_wakeup(tp);
 			break;
diff --git a/sys/vm/vm_object.h b/sys/vm/vm_object.h
index b7908f0034..1ad90455af 100644
--- a/sys/vm/vm_object.h
+++ b/sys/vm/vm_object.h
@@ -228,9 +228,13 @@ struct vm_object {
 
 #ifdef	_KERNEL
 
-#define OBJPC_SYNC	0x1			/* sync I/O */
-#define OBJPC_INVAL	0x2			/* invalidate */
-#define OBJPC_NOSYNC	0x4			/* skip if PG_NOSYNC */
+#define OBJPC_SYNC		0x0001	/* sync I/O */
+#define OBJPC_INVAL		0x0002	/* invalidate */
+#define OBJPC_NOSYNC		0x0004	/* skip if PG_NOSYNC */
+#define OBJPC_IGNORE_CLEANCHK	0x0008
+#define OBJPC_CLUSTER_OK	0x0010	/* used only by vnode pager */
+#define OBJPC_TRY_TO_CACHE	0x0020	/* typically used only in pageout path */
+#define OBJPC_ALLOW_ACTIVE	0x0040	/* dito */
 
 #if 0
 /*
diff --git a/sys/vm/vm_pageout.c b/sys/vm/vm_pageout.c
index bf3a0eabbe..d3652e5195 100644
--- a/sys/vm/vm_pageout.c
+++ b/sys/vm/vm_pageout.c
@@ -362,7 +362,7 @@ vm_pageout_clean_helper(vm_page_t m, int vmflush_flags)
 		}
 		if (p->queue - p->pc != PQ_INACTIVE) {
 			if (p->queue - p->pc != PQ_ACTIVE ||
-			    (vmflush_flags & VM_PAGER_ALLOW_ACTIVE) == 0) {
+			    (vmflush_flags & OBJPC_ALLOW_ACTIVE) == 0) {
 				vm_page_wakeup(p);
 				break;
 			}
@@ -405,7 +405,7 @@ vm_pageout_clean_helper(vm_page_t m, int vmflush_flags)
 		}
 		if (p->queue - p->pc != PQ_INACTIVE) {
 			if (p->queue - p->pc != PQ_ACTIVE ||
-			    (vmflush_flags & VM_PAGER_ALLOW_ACTIVE) == 0) {
+			    (vmflush_flags & OBJPC_ALLOW_ACTIVE) == 0) {
 				vm_page_wakeup(p);
 				break;
 			}
@@ -473,7 +473,7 @@ vm_pageout_flush(vm_page_t *mc, int count, int vmflush_flags)
 	 * of our soft-busy.
 	 */
 	for (i = 0; i < count; i++) {
-		if (vmflush_flags & VM_PAGER_TRY_TO_CACHE)
+		if (vmflush_flags & OBJPC_TRY_TO_CACHE)
 			vm_page_protect(mc[i], VM_PROT_NONE);
 		else
 			vm_page_protect(mc[i], VM_PROT_READ);
@@ -486,7 +486,7 @@ vm_pageout_flush(vm_page_t *mc, int count, int vmflush_flags)
 	vm_pager_put_pages(object, mc, count,
 			   (vmflush_flags |
 			    ((object == &kernel_object) ?
-				VM_PAGER_PUT_SYNC : 0)),
+				OBJPC_SYNC : 0)),
 			   pageout_status);
 
 	for (i = 0; i < count; i++) {
@@ -541,7 +541,7 @@ vm_pageout_flush(vm_page_t *mc, int count, int vmflush_flags)
 		if (pageout_status[i] != VM_PAGER_PEND) {
 			vm_page_busy_wait(mt, FALSE, "pgouw");
 			vm_page_io_finish(mt);
-			if (vmflush_flags & VM_PAGER_TRY_TO_CACHE) {
+			if (vmflush_flags & OBJPC_TRY_TO_CACHE) {
 				vm_page_try_to_cache(mt);
 			} else if (vm_page_count_severe()) {
 				vm_page_deactivate(mt);
@@ -670,10 +670,10 @@ vm_pageout_mdp_callback(struct pmap_pgscan_info *info, vm_offset_t va,
 		info->offset = va;
 
 		if (vm_pageout_memuse_mode >= 2) {
-			vmflush_flags = VM_PAGER_TRY_TO_CACHE |
-					VM_PAGER_ALLOW_ACTIVE;
+			vmflush_flags = OBJPC_TRY_TO_CACHE |
+					OBJPC_ALLOW_ACTIVE;
 			if (swap_user_async == 0)
-				vmflush_flags |= VM_PAGER_PUT_SYNC;
+				vmflush_flags |= OBJPC_SYNC;
 			vm_page_flag_set(p, PG_WINATCFLS);
 			info->cleancount +=
 				vm_pageout_page(p, &max_launder,
@@ -954,9 +954,9 @@ vm_pageout_scan_inactive(int pass, int q, long avail_shortage,
 
 		vmflush_flags = 0;
 		if (vm_pageout_allow_active)
-			vmflush_flags |= VM_PAGER_ALLOW_ACTIVE;
+			vmflush_flags |= OBJPC_ALLOW_ACTIVE;
 		if (m->flags & PG_WINATCFLS)
-			vmflush_flags |= VM_PAGER_TRY_TO_CACHE;
+			vmflush_flags |= OBJPC_TRY_TO_CACHE;
 		count = vm_pageout_page(m, &max_launder, vnodes_skipped,
 					&vpfailed, pass, vmflush_flags, counts);
 		delta += count;
diff --git a/sys/vm/vm_pager.h b/sys/vm/vm_pager.h
index e331286496..346930958c 100644
--- a/sys/vm/vm_pager.h
+++ b/sys/vm/vm_pager.h
@@ -87,13 +87,6 @@ struct pagerops {
 #define	VM_PAGER_ERROR	4
 #define VM_PAGER_AGAIN	5
 
-#define	VM_PAGER_PUT_SYNC		0x0001
-#define	VM_PAGER_PUT_INVAL		0x0002
-#define	VM_PAGER_IGNORE_CLEANCHK	0x0004
-#define	VM_PAGER_CLUSTER_OK		0x0008
-#define	VM_PAGER_TRY_TO_CACHE		0x0010
-#define	VM_PAGER_ALLOW_ACTIVE		0x0020
-
 #ifdef _KERNEL
 
 struct vnode;
diff --git a/sys/vm/vnode_pager.c b/sys/vm/vnode_pager.c
index 64506fa3a0..90c50eae3b 100644
--- a/sys/vm/vnode_pager.c
+++ b/sys/vm/vnode_pager.c
@@ -743,11 +743,11 @@ vnode_pager_generic_putpages(struct vnode *vp, vm_page_t *m, int bytecount,
 	 * the system decides how to cluster.
 	 */
 	ioflags = IO_VMIO;
-	if (flags & (VM_PAGER_PUT_SYNC | VM_PAGER_PUT_INVAL))
+	if (flags & (OBJPC_SYNC | OBJPC_INVAL))
 		ioflags |= IO_SYNC;
-	else if ((flags & VM_PAGER_CLUSTER_OK) == 0)
+	else if ((flags & OBJPC_CLUSTER_OK) == 0)
 		ioflags |= IO_ASYNC;
-	ioflags |= (flags & VM_PAGER_PUT_INVAL) ? IO_INVAL: 0;
+	ioflags |= (flags & OBJPC_INVAL) ? IO_INVAL: 0;
 	ioflags |= IO_SEQMAX << IO_SEQSHIFT;
 
 	aiov.iov_base = (caddr_t) 0;